#line 1 "C:/Users/user/Desktop/Half_Bridge/SPWM.c"
 unsigned char sin_table[32]={0, 25, 49, 73, 96, 118, 139, 159, 177,
 193, 208, 220, 231, 239, 245, 249, 250, 249, 245,
 239, 231, 220, 208, 193, 177, 159, 139, 118, 96, 73, 49, 25};

unsigned int TBL_POINTER_NEW, TBL_POINTER_OLD, TBL_POINTER_SHIFT, SET_FREQ;
unsigned int TBL_temp;
unsigned char DUTY_CYCLE;

char text1[]="Solar Volts:";
char text2[]="Output:";



sbit LCD_RS at RC3_bit;
sbit LCD_EN at RD0_bit;

sbit LCD_D4 at RD1_bit;
sbit LCD_D5 at RD2_bit;
sbit LCD_D6 at RD3_bit;
sbit LCD_D7 at RD4_bit;

sbit LCD_RS_Direction at TRISC3_bit;
sbit LCD_EN_Direction at TRISD0_bit;
sbit LCD_D4_Direction at TRISD1_bit;
sbit LCD_D5_Direction at TRISD2_bit;
sbit LCD_D6_Direction at TRISD3_bit;
sbit LCD_D7_Direction at TRISD4_bit;

void interrupt()

 {
 if (TMR2IF_bit == 1){
 TBL_POINTER_NEW = TBL_POINTER_OLD + SET_FREQ;
 if (TBL_POINTER_NEW < TBL_POINTER_OLD){
 CCP1CON.P1M1 = ~CCP1CON.P1M1;
 }
 TBL_POINTER_SHIFT = TBL_POINTER_NEW >> 12;
 DUTY_CYCLE = TBL_POINTER_SHIFT;
 CCPR1L = sin_table[DUTY_CYCLE];
 TBL_POINTER_OLD = TBL_POINTER_NEW;
 TMR2IF_bit = 0;
 }
}
void main() {

 ADC_Init();

 SET_FREQ =556;
 TBL_POINTER_SHIFT = 0;
 TBL_POINTER_NEW = 0;
 TBL_POINTER_OLD = 0;
 DUTY_CYCLE = 0;
 ANSELA = 0x0F;

 PR2 = 249;
 TRISC = 0xF3;
 PORTC=0XF3;

 TRISD=0;
 PORTD=0;

 TRISA=0x0F;
 PORTA=0x0F;

 TRISB=0X01;
 PORTB=0x01;

 CCP1CON = 0x4C;
 PWM1CON=80;
 TMR2IF_bit = 0;
 T2CON = 4;
 while (TMR2IF_bit == 0);
 TMR2IF_bit = 0;
 TRISC = 0x00;
 TRISD=0X00;
 TMR2IE_bit = 1;
 GIE_bit = 1;
 PEIE_bit = 1;

 Lcd_Init();
 LCD_Cmd(_LCD_CLEAR);
 LCD_Cmd(_LCD_CURSOR_OFF);

 do{

 Lcd_Out(2,1, text1);
 delay_ms(1500);
 }

 while(1);



}
